<?php

/**
 * consol_aportes_cesantias actions.
 *
 * @package    nomina
 * @subpackage consol_aportes_cesantias
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class consol_aportes_cesantiasActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' ORDER BY tab0.num_doc, tab0.id_anhos ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            //$periodo_filtro = $request['id_periodo_filtro'];
            $id_anhos = $request['id_anhos'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //clase planta - sin clase planta
            if (isset($request['id_clase_planta'])) {
                $whereClasePlanta = " AND tab0.id_clase_planta = " . $request['id_clase_planta'];
            } else {
                $whereClasePlanta = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select

tab0.id_anhos,
tab0.id_tipo_doc,
tab0.num_doc,
tab0.nombre_apellido,
tab0.nombre_completo,

tab0.id_clase_planta,
tab0.codigo,
tab0.descripcion,

sum( nvl(tab0.valor_liquidado_enero,0) ) as valor_liquidado_enero,    
sum( nvl(tab0.valor_base_enero,0) ) as valor_base_enero,    
sum( nvl(tab0.num_dias_enero,0) )as num_dias_enero,

sum( nvl(tab0.valor_liquidado_febrero,0) ) as valor_liquidado_febrero,    
sum( nvl(tab0.valor_base_febrero,0) ) as valor_base_febrero,    
sum( nvl(tab0.num_dias_febrero,0) )as num_dias_febrero,

sum( nvl(tab0.valor_liquidado_marzo,0) ) as valor_liquidado_marzo,    
sum( nvl(tab0.valor_base_marzo,0) ) as valor_base_marzo,    
sum( nvl(tab0.num_dias_marzo,0) )as num_dias_marzo,

sum( nvl(tab0.valor_liquidado_abril,0) ) as valor_liquidado_abril,    
sum( nvl(tab0.valor_base_abril,0) ) as valor_base_abril,    
sum( nvl(tab0.num_dias_abril,0) )as num_dias_abril,

sum( nvl(tab0.valor_liquidado_mayo,0) ) as valor_liquidado_mayo,    
sum( nvl(tab0.valor_base_mayo,0) ) as valor_base_mayo,    
sum( nvl(tab0.num_dias_mayo,0) )as num_dias_mayo,

sum( nvl(tab0.valor_liquidado_junio,0) ) as valor_liquidado_junio,    
sum( nvl(tab0.valor_base_junio,0) ) as valor_base_junio,    
sum( nvl(tab0.num_dias_junio,0) )as num_dias_junio,

sum( nvl(tab0.valor_liquidado_julio,0) ) as valor_liquidado_julio,    
sum( nvl(tab0.valor_base_julio,0) ) as valor_base_julio,    
sum( nvl(tab0.num_dias_julio,0) )as num_dias_julio,

sum( nvl(tab0.valor_liquidado_agosto,0) ) as valor_liquidado_agosto,    
sum( nvl(tab0.valor_base_agosto,0) ) as valor_base_agosto,    
sum( nvl(tab0.num_dias_agosto,0) )as num_dias_agosto,

sum( nvl(tab0.valor_liquidado_septiembre,0) ) as valor_liquidado_septiembre,    
sum( nvl(tab0.valor_base_septiembre,0) ) as valor_base_septiembre,    
sum( nvl(tab0.num_dias_septiembre,0) )as num_dias_septiembre,

sum( nvl(tab0.valor_liquidado_octubre,0) ) as valor_liquidado_octubre,    
sum( nvl(tab0.valor_base_octubre,0) ) as valor_base_octubre,    
sum( nvl(tab0.num_dias_octubre,0) )as num_dias_octubre,

sum( nvl(tab0.valor_liquidado_noviembre,0) ) as valor_liquidado_noviembre,    
sum( nvl(tab0.valor_base_noviembre,0) ) as valor_base_noviembre,    
sum( nvl(tab0.num_dias_noviembre,0) )as num_dias_noviembre,

sum( nvl(tab0.valor_liquidado_diciembre,0) ) as valor_liquidado_diciembre,    
sum( nvl(tab0.valor_base_diciembre,0) ) as valor_base_diciembre,    
sum( nvl(tab0.num_dias_diciembre,0) )as num_dias_diciembre, 
    
sum( nvl( tab0.valor_liquidado_total,0) ) as valor_liquidado_total

FROM(

    select 
    
    per.id_anhos,
    per.id_meses,
    ces.id_periodo,
    ces.id_tipo_doc,
    ces.num_doc,
    dat.nombre_apellido,
    dat.nombre_completo,
    
    nom.id_clase_planta,
    cla.codigo,
    cla.descripcion,
    
    nvl( case when per.id_meses = 1 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_enero,    
    nvl( case when per.id_meses = 1 then nvl( ces.valor_base,0) else null end ,0) as valor_base_enero,    
    nvl( case when per.id_meses = 1 then nvl( ces.num_dias,0) else null end ,0) as num_dias_enero,
    
    nvl( case when per.id_meses = 2 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_febrero,    
    nvl( case when per.id_meses = 2 then nvl( ces.valor_base,0) else null end ,0) as valor_base_febrero,    
    nvl( case when per.id_meses = 2 then nvl( ces.num_dias,0) else null end ,0) as num_dias_febrero,
    
    nvl( case when per.id_meses = 3 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_marzo,    
    nvl( case when per.id_meses = 3 then nvl( ces.valor_base,0) else null end ,0) as valor_base_marzo,
    nvl( case when per.id_meses = 3 then nvl( ces.num_dias,0) else null end ,0) as num_dias_marzo,
    
    nvl( case when per.id_meses = 4 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_abril,    
    nvl( case when per.id_meses = 4 then nvl( ces.valor_base,0) else null end ,0) as valor_base_abril,    
    nvl( case when per.id_meses = 4 then nvl( ces.num_dias,0) else null end ,0) as num_dias_abril,
    
    nvl( case when per.id_meses = 5 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_mayo,    
    nvl( case when per.id_meses = 5 then nvl( ces.valor_base,0) else null end ,0) as valor_base_mayo,    
    nvl( case when per.id_meses = 5 then nvl( ces.num_dias,0) else null end ,0) as num_dias_mayo,
    
    nvl( case when per.id_meses = 6 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_junio,    
    nvl( case when per.id_meses = 6 then nvl( ces.valor_base,0) else null end ,0) as valor_base_junio,    
    nvl( case when per.id_meses = 6 then nvl( ces.num_dias,0) else null end ,0) as num_dias_junio,
    
    nvl( case when per.id_meses = 7 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_julio,    
    nvl( case when per.id_meses = 7 then nvl( ces.valor_base,0) else null end ,0) as valor_base_julio,    
    nvl( case when per.id_meses = 7 then nvl( ces.num_dias,0) else null end ,0) as num_dias_julio,
    
    nvl( case when per.id_meses = 8 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_agosto,    
    nvl( case when per.id_meses = 8 then nvl( ces.valor_base,0) else null end ,0) as valor_base_agosto,    
    nvl( case when per.id_meses = 8 then nvl( ces.num_dias,0) else null end ,0) as num_dias_agosto,
    
    nvl( case when per.id_meses = 9 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_septiembre,    
    nvl( case when per.id_meses = 9 then nvl( ces.valor_base,0) else null end ,0) as valor_base_septiembre,    
    nvl( case when per.id_meses = 9 then nvl( ces.num_dias,0) else null end ,0) as num_dias_septiembre,
    
    nvl( case when per.id_meses = 10 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_octubre,    
    nvl( case when per.id_meses = 10 then nvl( ces.valor_base,0) else null end ,0) as valor_base_octubre,    
    nvl( case when per.id_meses = 10 then nvl( ces.num_dias,0) else null end ,0) as num_dias_octubre,
    
    nvl( case when per.id_meses = 11 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_noviembre,    
    nvl( case when per.id_meses = 11 then nvl( ces.valor_base,0) else null end ,0) as valor_base_noviembre,    
    nvl( case when per.id_meses = 11 then nvl( ces.num_dias,0) else null end ,0) as num_dias_noviembre,
    
    nvl( case when per.id_meses = 12 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_diciembre,    
    nvl( case when per.id_meses = 12 then nvl( ces.valor_base,0) else null end ,0) as valor_base_diciembre,    
    nvl( case when per.id_meses = 12 then nvl( ces.num_dias,0) else null end ,0) as num_dias_diciembre, 
    
    nvl( ces.valor_liquidado,0) as valor_liquidado_total
    
    from no_cesantia ces
    
    left join no_datos_funcionario_v dat
    on dat.id_tipo_doc = ces.id_tipo_doc
    and dat.num_doc = ces.num_doc
    
    left join no_nombramiento_v nom
    on nom.id_tipo_doc = ces.id_tipo_doc
    and nom.num_doc = ces.num_doc
    
    left join no_clase_planta cla
    on nom.id_clase_planta = cla.id_clase_planta
    
    left join no_periodo_v per
    on per.id_periodo = ces.id_periodo
    
    where
    ces.consolidado = 0
    and per.id_tipo_periodo = 1

)tab0

where
tab0.id_anhos = $id_anhos
$whereFuncionarioTipoDoc $whereFuncionarioNumDoc                     
$whereClasePlanta 

group by
tab0.id_anhos,
tab0.id_tipo_doc,
tab0.num_doc,
tab0.nombre_apellido,
tab0.nombre_completo,
tab0.id_clase_planta,
tab0.codigo,
tab0.descripcion


)
EOD;

            //ejecuta y obtiene el resultado del sql
            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select

tab0.id_anhos,
tab0.id_tipo_doc,
tab0.num_doc,
tab0.nombre_apellido,
tab0.nombre_completo,

tab0.id_clase_planta,
tab0.codigo,
tab0.descripcion,

sum( nvl(tab0.valor_liquidado_enero,0) ) as valor_liquidado_enero,    
sum( nvl(tab0.valor_base_enero,0) ) as valor_base_enero,    
sum( nvl(tab0.num_dias_enero,0) )as num_dias_enero,

sum( nvl(tab0.valor_liquidado_febrero,0) ) as valor_liquidado_febrero,    
sum( nvl(tab0.valor_base_febrero,0) ) as valor_base_febrero,    
sum( nvl(tab0.num_dias_febrero,0) )as num_dias_febrero,

sum( nvl(tab0.valor_liquidado_marzo,0) ) as valor_liquidado_marzo,    
sum( nvl(tab0.valor_base_marzo,0) ) as valor_base_marzo,    
sum( nvl(tab0.num_dias_marzo,0) )as num_dias_marzo,

sum( nvl(tab0.valor_liquidado_abril,0) ) as valor_liquidado_abril,    
sum( nvl(tab0.valor_base_abril,0) ) as valor_base_abril,    
sum( nvl(tab0.num_dias_abril,0) )as num_dias_abril,

sum( nvl(tab0.valor_liquidado_mayo,0) ) as valor_liquidado_mayo,    
sum( nvl(tab0.valor_base_mayo,0) ) as valor_base_mayo,    
sum( nvl(tab0.num_dias_mayo,0) )as num_dias_mayo,

sum( nvl(tab0.valor_liquidado_junio,0) ) as valor_liquidado_junio,    
sum( nvl(tab0.valor_base_junio,0) ) as valor_base_junio,    
sum( nvl(tab0.num_dias_junio,0) )as num_dias_junio,

sum( nvl(tab0.valor_liquidado_julio,0) ) as valor_liquidado_julio,    
sum( nvl(tab0.valor_base_julio,0) ) as valor_base_julio,    
sum( nvl(tab0.num_dias_julio,0) )as num_dias_julio,

sum( nvl(tab0.valor_liquidado_agosto,0) ) as valor_liquidado_agosto,    
sum( nvl(tab0.valor_base_agosto,0) ) as valor_base_agosto,    
sum( nvl(tab0.num_dias_agosto,0) )as num_dias_agosto,

sum( nvl(tab0.valor_liquidado_septiembre,0) ) as valor_liquidado_septiembre,    
sum( nvl(tab0.valor_base_septiembre,0) ) as valor_base_septiembre,    
sum( nvl(tab0.num_dias_septiembre,0) )as num_dias_septiembre,

sum( nvl(tab0.valor_liquidado_octubre,0) ) as valor_liquidado_octubre,    
sum( nvl(tab0.valor_base_octubre,0) ) as valor_base_octubre,    
sum( nvl(tab0.num_dias_octubre,0) )as num_dias_octubre,

sum( nvl(tab0.valor_liquidado_noviembre,0) ) as valor_liquidado_noviembre,    
sum( nvl(tab0.valor_base_noviembre,0) ) as valor_base_noviembre,    
sum( nvl(tab0.num_dias_noviembre,0) )as num_dias_noviembre,

sum( nvl(tab0.valor_liquidado_diciembre,0) ) as valor_liquidado_diciembre,    
sum( nvl(tab0.valor_base_diciembre,0) ) as valor_base_diciembre,    
sum( nvl(tab0.num_dias_diciembre,0) )as num_dias_diciembre, 
    
sum( nvl( tab0.valor_liquidado_total,0) ) as valor_liquidado_total

FROM(

    select 
    
    per.id_anhos,
    per.id_meses,
    ces.id_periodo,
    ces.id_tipo_doc,
    ces.num_doc,
    dat.nombre_apellido,
    dat.nombre_completo,
    
    nom.id_clase_planta,
    cla.codigo,
    cla.descripcion,
    
    nvl( case when per.id_meses = 1 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_enero,    
    nvl( case when per.id_meses = 1 then nvl( ces.valor_base,0) else null end ,0) as valor_base_enero,    
    nvl( case when per.id_meses = 1 then nvl( ces.num_dias,0) else null end ,0) as num_dias_enero,
    
    nvl( case when per.id_meses = 2 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_febrero,    
    nvl( case when per.id_meses = 2 then nvl( ces.valor_base,0) else null end ,0) as valor_base_febrero,    
    nvl( case when per.id_meses = 2 then nvl( ces.num_dias,0) else null end ,0) as num_dias_febrero,
    
    nvl( case when per.id_meses = 3 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_marzo,    
    nvl( case when per.id_meses = 3 then nvl( ces.valor_base,0) else null end ,0) as valor_base_marzo,
    nvl( case when per.id_meses = 3 then nvl( ces.num_dias,0) else null end ,0) as num_dias_marzo,
    
    nvl( case when per.id_meses = 4 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_abril,    
    nvl( case when per.id_meses = 4 then nvl( ces.valor_base,0) else null end ,0) as valor_base_abril,    
    nvl( case when per.id_meses = 4 then nvl( ces.num_dias,0) else null end ,0) as num_dias_abril,
    
    nvl( case when per.id_meses = 5 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_mayo,    
    nvl( case when per.id_meses = 5 then nvl( ces.valor_base,0) else null end ,0) as valor_base_mayo,    
    nvl( case when per.id_meses = 5 then nvl( ces.num_dias,0) else null end ,0) as num_dias_mayo,
    
    nvl( case when per.id_meses = 6 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_junio,    
    nvl( case when per.id_meses = 6 then nvl( ces.valor_base,0) else null end ,0) as valor_base_junio,    
    nvl( case when per.id_meses = 6 then nvl( ces.num_dias,0) else null end ,0) as num_dias_junio,
    
    nvl( case when per.id_meses = 7 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_julio,    
    nvl( case when per.id_meses = 7 then nvl( ces.valor_base,0) else null end ,0) as valor_base_julio,    
    nvl( case when per.id_meses = 7 then nvl( ces.num_dias,0) else null end ,0) as num_dias_julio,
    
    nvl( case when per.id_meses = 8 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_agosto,    
    nvl( case when per.id_meses = 8 then nvl( ces.valor_base,0) else null end ,0) as valor_base_agosto,    
    nvl( case when per.id_meses = 8 then nvl( ces.num_dias,0) else null end ,0) as num_dias_agosto,
    
    nvl( case when per.id_meses = 9 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_septiembre,    
    nvl( case when per.id_meses = 9 then nvl( ces.valor_base,0) else null end ,0) as valor_base_septiembre,    
    nvl( case when per.id_meses = 9 then nvl( ces.num_dias,0) else null end ,0) as num_dias_septiembre,
    
    nvl( case when per.id_meses = 10 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_octubre,    
    nvl( case when per.id_meses = 10 then nvl( ces.valor_base,0) else null end ,0) as valor_base_octubre,    
    nvl( case when per.id_meses = 10 then nvl( ces.num_dias,0) else null end ,0) as num_dias_octubre,
    
    nvl( case when per.id_meses = 11 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_noviembre,    
    nvl( case when per.id_meses = 11 then nvl( ces.valor_base,0) else null end ,0) as valor_base_noviembre,    
    nvl( case when per.id_meses = 11 then nvl( ces.num_dias,0) else null end ,0) as num_dias_noviembre,
    
    nvl( case when per.id_meses = 12 then nvl( ces.valor_liquidado,0) else null end ,0) as valor_liquidado_diciembre,    
    nvl( case when per.id_meses = 12 then nvl( ces.valor_base,0) else null end ,0) as valor_base_diciembre,    
    nvl( case when per.id_meses = 12 then nvl( ces.num_dias,0) else null end ,0) as num_dias_diciembre, 
    
    nvl( ces.valor_liquidado,0) as valor_liquidado_total
    
    from no_cesantia ces
    
    left join no_datos_funcionario_v dat
    on dat.id_tipo_doc = ces.id_tipo_doc
    and dat.num_doc = ces.num_doc
    
    left join no_nombramiento_v nom
    on nom.id_tipo_doc = ces.id_tipo_doc
    and nom.num_doc = ces.num_doc
    
    left join no_clase_planta cla
    on nom.id_clase_planta = cla.id_clase_planta
    
    left join no_periodo_v per
    on per.id_periodo = ces.id_periodo
    
    where
    ces.consolidado = 0
    and per.id_tipo_periodo = 1

)tab0

where
tab0.id_anhos = $id_anhos
$whereFuncionarioTipoDoc $whereFuncionarioNumDoc                     
$whereClasePlanta                    

group by
tab0.id_anhos,
tab0.id_tipo_doc,
tab0.num_doc,
tab0.nombre_apellido,
tab0.nombre_completo,
tab0.id_clase_planta,
tab0.codigo,
tab0.descripcion

$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[consol_aportes_cesantias] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
